# c版をski.comが作成
# pyに>_<が移植中

import argparse as ap
import os.path
import sys
import json

sys.path.append(os.path.dirname(os.path.dirname(os.path.dirname(__file__))))
from maiwashi import version_key

SYSTEM_VERSION="0.2.0"
STATIC_EVENTS_DICT={}

def uuid2name(uuid:str):return "umihebi_"+uuid.replace("-", "_")

parser = ap.ArgumentParser(
	prog="tail",
	description="プロジェクトを実行ファイルにするやつです。"
	)
parser.add_argument("project_dir", help="実行ファイルにしたいプロジェクトのフォルダの名前。")

# >_< によるpy移植のための変更 ... cコンパイラはいらない
#parser.add_argument("-c","--tcc", help="tccのパス。",default=os.path.join(os.path.dirname(os.path.abspath(sys.argv[0])),"tcc-0.9.27-win64-bin\\tcc"))
#parser.add_argument("-o","--out", help="出力先のパス。",default=None)
args = parser.parse_args()
if args.project_dir[-1] in {"/","\\"}:
	args.project_dir=args.project_dir[:-1]
with open(os.path.join(args.project_dir, "data.json")) as fp:
	data = json.load(fp)
target_ver=version_key(data["system"]["version"])
match target_ver[:2]:
	case (0,2):
		def tmp_func():
			def transpile_exp(dec) -> str:
				match dec["type"]:
					case "exp_literal":
						match dec["value_type"]:
							case "string"|"int"|"float":
								return repr(dec["value"])
					case "exp_funcall":
						return f"{transpile_exp(dec['callee'])}({','.join(transpile_exp(a)for a in dec['args'])})"
					case "exp_ref_id":
						return uuid2name(dec["id"])
				assert False
			def transpile_stm(stm) -> str:
				match stm["type"][:3]:
					case "exp":
						return transpile_exp(stm)+";"
					case "dec":
						return transpile_dec(dec)
					case "stm":
						match stm["type"]:
							case _:
								pass
				assert False
			def transpile_dec(dec) -> str:
				match dec["type"]:
					case "dec_observe":
						raise NotImplementedError()
					case _:
						assert False
			for dec in data["programs"]:
				match dec["type"]:
					case "dec_observe":
						if dec["event"] not in STATIC_EVENTS_DICT:
							STATIC_EVENTS_DICT[dec["event"]]=""
						tmp=""
						for stmt in dec["body"]:
							tmp+=transpile_stm(stmt)
						STATIC_EVENTS_DICT[dec["event"]]+=tmp+"\n"
					case _:
						assert False
			code="from pythonRuntime import *\n\n"
			val:str
			for uuid,val in STATIC_EVENTS_DICT.items():
				code+=f"def {uuid2name(uuid)}():{val}\n"
			code+='if __name__=="__main__":umihebi_BE9BADA0_030E_4AC8_8664_E5129DE50B6C()'
			tmp_py_name=os.path.join(os.path.dirname(__file__), "out.py")
			with open(tmp_py_name, "w", encoding="utf-8") as fp:
				fp.write(code)
		tmp_func()	
	case _:
		print(f"バージョン「{data['system']['version']}」の形式のプロジェクトは対応していません。")
